#!/usr/bin/python
#
# mcast_recv.py - simple multicast receiving utility for testing
#
# Usage:
#   mcast_send.py [multicast_group]
#    Default multicast_group: 224.7.7.7
#
# Ctrl+C to exit
#
# Based on code examples at http://wiki.python.org/moin/UdpCommunication
#

PORT = 12345

import sys, os, time, socket, struct

mc_group = '224.7.7.7'
if len(sys.argv) > 1: mc_group = sys.argv[1]

sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, socket.IPPROTO_UDP)
sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
sock.bind(('', PORT))

mreq = struct.pack("4sl", socket.inet_aton(mc_group), socket.INADDR_ANY)
sock.setsockopt(socket.IPPROTO_IP, socket.IP_ADD_MEMBERSHIP, mreq)

print '>> Multicast group:', mc_group
while True:
    print sock.recv(10240)


